// Txr.h: interface for the CTxr class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TXR_H__34FEAF9F_85B8_45E1_B90D_A45641276100__INCLUDED_)
#define AFX_TXR_H__34FEAF9F_85B8_45E1_B90D_A45641276100__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TxtRead.h"
#ifdef   _WIN32
#include <Shlwapi.h>
#endif

class CTxr  
{
public:
	static bool MakeDirs (CString sFile);
   static int FindExt (CString sPath);
   static CString AddExt (CString sPath, CString sExt);
   static CString ChangeExt (CString sPath, CString sExt);
   static CString AbsPath (CString sRelPath);
   static CString RelPath (CString sFile, CString sOrig,
      int iAttr = FILE_ATTRIBUTE_DIRECTORY);
   static CString RelPath (CString sFile);
	void Rewind (void);
	int GetFileSize (void);
	int GetFilePos ();
	void NextLine (int nSkip = 1);
	bool GetBool (void);
	bool Eof (void);
   bool Eol (void);
	int GetTerm (void);
	double GetReal (void);
	int GetInt (void);
	CString GetString (void);
	CString GetLine (void);
   void SetQuote (const char *psQuote);
	void SetTerm (const char *psTerm);
	void SetMode (TxrMode txrm);
	void Close (void);
	bool Open (const char *psFile);
	CTxr();
	CTxr (TxrMode txrm);
	CTxr (TxrMode txrm, const char *psTerm);
	virtual ~CTxr();

private:
	static void AppendChr (void *pctxr, int iChr);
	CString m_strTerm;
   CString  m_strQuote;
	TxrMode m_txrm;
	CString m_strText;
	TXR * m_ptxr;
};

#endif // !defined(AFX_TXR_H__34FEAF9F_85B8_45E1_B90D_A45641276100__INCLUDED_)
