/*

diag.h - Diagnostic code

*/

#ifndef DIAG_H
#define	DIAG_H

/*...sincludes:0:*/
#include <stdlib.h>
#include <stdarg.h>

#include "types.h"

/*...vtypes\46\h:0:*/
/*...e*/

#define	DIAGM_CONSOLE               0x00000001
#define	DIAGM_FILE                  0x00000002
#define	DIAGM_RING                  0x00000004

#define	DIAG_ALWAYS                   0
#define	DIAG_WIN_UNKNOWN_KEY          1
#define	DIAG_MEM_IOBYTE               2
#define	DIAG_MEM_SUBPAGE              3
#define	DIAG_MEM_DUMP                 4
#define	DIAG_VID_STATUS               5
#define	DIAG_VID_REGISTERS            6
#define	DIAG_VID_ADDRESS              7
#define	DIAG_VID_DATA                 8
#define	DIAG_VID_REFRESH              9
#define	DIAG_VID_MARKERS             10
#define	DIAG_KBD_WIN_KEY             11
#define	DIAG_KBD_SENSE               12
#define	DIAG_KBD_AUTO_TYPE           13
#define	DIAG_KBD_REMAP               14
#define	DIAG_JOY_INIT                15
#define	DIAG_JOY_USAGE               16
#define	DIAG_SND_REGISTERS           17
#define	DIAG_SND_LATENCY             18
#define	DIAG_CTC_REGISTERS           19
#define	DIAG_CTC_PENDING             20
#define	DIAG_CTC_INTERRUPT           21
#define	DIAG_MON_HW                  22
#define	DIAG_MON_KBD_WIN_KEY         23
#define	DIAG_MON_KBD_MAP_TH          24
#define	DIAG_SDXFDC_PORT             25
#define	DIAG_SDXFDC_HW               26
#define	DIAG_SDXFDC_DATA             27
#define	DIAG_SDXFDC_STATUS           28
#define	DIAG_SIDISC_FILE             29
#define	DIAG_SIDISC_ADDRESS          30
#define	DIAG_SIDISC_DATA             31
#define	DIAG_PRINT                   32
#define	DIAG_CPM_DRIVER              33
#define	DIAG_CPM_CBIOS               34
#define	DIAG_CPM_BDOS_FILE           35
#define	DIAG_CPM_BDOS_OTHER          36
#define	DIAG_Z80_INSTRUCTIONS        37
#define	DIAG_Z80_INSTRUCTIONS_NEW    38
#define	DIAG_Z80_INTERRUPTS          39
#define	DIAG_BAD_PORT                40
#define	DIAG_PANEL_HACK              41
#define	DIAG_TAPE                    42
#define	DIAG_SPEED                   43
#define	DIAG_SPEED_UP                44
#define	DIAG_EXIT                    45
#define DIAG_HW_WIN                  46	/* RPi */
#define DIAG_HW_KBD                  47	/* RPi */
#define	DIAG_DART_PORTS              48
#define	DIAG_DART_CFG                49
#define DIAG_DART_DATA               50
#define	DIAG_SPEC_PORTS              51
#define	DIAG_SPEC_INTERRUPTS         52
#define	DIAG_ACT_VID_REGS            53
#define	DIAG_ACT_Z80_REGS            54
#define	DIAG_ACT_MEM_DUMP            55
#define	DIAG_ACT_SNA_LOAD            56
#define	DIAG_ACT_SNA_SAVE            57
#define	DIAG_ACT_TAP_REWIND          58
#define	DIAG_ACT_VID_SNAPSHOT        59
#define	DIAG_VID_AUTO_SNAPSHOT       60
#define DIAG_DART_HW                 61
#define DIAG_NODE_PKT_TX             62
#define DIAG_NODE_PKT_RX             63
#define DIAG_LOG_TYPE                64
#define	DIAG_COUNT                   65	/* Must be last entry and largest value */

extern unsigned int diag_methods;

extern unsigned int diag_method_of(const char *s);

extern BOOLEAN diag_flags[DIAG_COUNT];

extern BOOLEAN diag_flag_of(const char *s);

extern void diag_message(unsigned int flag, const char *fmt, ...);

extern void diag_control(int c);

extern void diag_init(void);

extern void diag_term(void);

#endif
