/*

key.h - Interface keyboard handler

*/

#define	K_CTRL(c)	((c)&0x1f)
#define	K_BS		0x0008
#define	K_TAB		0x0009
#define	K_CR		0x000d
#define	K_LF		0x000a
#define	K_ESC		0x001b
#define	K_DEL		0x007f

#define	K_F1		0x3b00
#define	K_F2		0x3c00
#define	K_F3		0x3d00
#define	K_F4		0x3e00
#define	K_F5		0x3f00
#define	K_F6		0x4000
#define	K_F7		0x4100
#define	K_F8		0x4200
#define	K_F9		0x4300
#define	K_F10		0x4400
#define	K_F11		0x8500
#define	K_F12		0x8600

#define	K_SHIFT_F1	0x5400
#define	K_SHIFT_F2	0x5500
#define	K_SHIFT_F3	0x5600
#define	K_SHIFT_F4	0x5700
#define	K_SHIFT_F5	0x5800
#define	K_SHIFT_F6	0x5900
#define	K_SHIFT_F7	0x5a00
#define	K_SHIFT_F8	0x5b00
#define	K_SHIFT_F9	0x5c00
#define	K_SHIFT_F10	0x5d00
#define	K_SHIFT_F11	0x8700
#define	K_SHIFT_F12	0x8800

#define	K_CTRL_F1	0x5e00
#define	K_CTRL_F2	0x5f00
#define	K_CTRL_F3	0x6000
#define	K_CTRL_F4	0x6100
#define	K_CTRL_F5	0x6200
#define	K_CTRL_F6	0x6300
#define	K_CTRL_F7	0x6400
#define	K_CTRL_F8	0x6500
#define	K_CTRL_F9	0x6600
#define	K_CTRL_F10	0x6700
#define	K_CTRL_F11	0x8900
#define	K_CTRL_F12	0x8a00

#define	K_ALT_F1	0x6800
#define	K_ALT_F2	0x6900
#define	K_ALT_F3	0x6a00
#define	K_ALT_F4	0x6b00
#define	K_ALT_F5	0x6c00
#define	K_ALT_F6	0x6d00
#define	K_ALT_F7	0x6e00
#define	K_ALT_F8	0x6f00
#define	K_ALT_F9	0x7000
#define	K_ALT_F10	0x7100
#define	K_ALT_F11	0x8b00
#define	K_ALT_F12	0x8c00

#define	K_UP		0x4800
#define	K_DOWN		0x5000
#define	K_LEFT		0x4b00
#define	K_RIGHT		0x4d00
#define	K_PGUP		0x4900
#define	K_PGDN		0x5100
#define	K_INSERT	0x5200
#define	K_DELETE	0x5300
#define	K_HOME		0x4700
#define	K_END		0x4f00

#define	K_CTRL_UP	0x8d00
#define	K_CTRL_DOWN	0x9100
#define	K_CTRL_LEFT	0x7300
#define	K_CTRL_RIGHT	0x7400
#define	K_CTRL_PGUP	0x8400
#define	K_CTRL_PGDN	0x7600
#define	K_CTRL_INSERT	0x9200
#define	K_CTRL_DELETE	0x9300
#define	K_CTRL_HOME	0x7700
#define	K_CTRL_END	0x7500

#define	K_ALT_UP	0x9800
#define	K_ALT_DOWN	0xa000
#define	K_ALT_LEFT	0x9b00
#define	K_ALT_RIGHT	0x9d00
#define	K_ALT_PGUP	0x9900
#define	K_ALT_PGDN	0xa100
#define	K_ALT_INSERT	0xa200
#define	K_ALT_DELETE	0xa300
#define	K_ALT_HOME	0x9700
#define	K_ALT_END	0x9f00

#define	K_SHIFT_TAB	0x0f00
#define	K_CTRL_TAB	0x9400
#define	K_ALT_TAB	0xa500

#define	K_CTRL_G_PLUS	0x9000
#define	K_CTRL_G_MINUS	0x8e00
#define	K_ALT_G_PLUS	0x4e00
#define	K_ALT_G_MINUS	0x4a00

#define	K_ALT_A		0x1e00
#define	K_ALT_B		0x3000
#define	K_ALT_C		0x2e00
#define	K_ALT_D		0x2000
#define	K_ALT_E		0x1200
#define	K_ALT_F		0x2100
#define	K_ALT_G		0x2200
#define	K_ALT_H		0x2300
#define	K_ALT_I		0x1700
#define	K_ALT_J		0x2400
#define	K_ALT_K		0x2500
#define	K_ALT_L		0x2600
#define	K_ALT_M		0x3200
#define	K_ALT_N		0x3100
#define	K_ALT_O		0x1800
#define	K_ALT_P		0x1900
#define	K_ALT_Q		0x1000
#define	K_ALT_R		0x1300
#define	K_ALT_S		0x1f00
#define	K_ALT_T		0x1400
#define	K_ALT_U		0x1600
#define	K_ALT_V		0x2f00
#define	K_ALT_W		0x1100
#define	K_ALT_X		0x2d00
#define	K_ALT_Y		0x1500
#define	K_ALT_Z		0x2c00

#define	K_ALT_0		0x8100
#define	K_ALT_1		0x7800
#define	K_ALT_2		0x7900
#define	K_ALT_3		0x7a00
#define	K_ALT_4		0x7b00
#define	K_ALT_5		0x7c00
#define	K_ALT_6		0x7d00
#define	K_ALT_7		0x7e00
#define	K_ALT_8		0x7f00
#define	K_ALT_9		0x8000

#define	K_ALT_MINUS	0x8200
#define	K_ALT_EQUALS	0x8300
#define	K_ALT_BS	0x0e00
#define	K_5		0x4c00

extern void cdecl key_init(void);	/* Disable break and initialise      */
extern void cdecl key_deinit(void);	/* Re-enable break and deinitialise  */
extern int cdecl key_read(void);	/* Wait for next key and return it   */
extern int cdecl key_status(void);	/* Return key next in buffer, else 0 */
extern int cdecl key_break(void);	/* Returns TRUE if Ctrl-Break has    */
					/* been pressed and resets flag for  */
					/* the next call to key_break()      */
